function gX = cmpndKernDiagGradX(kern, X)

% CMPNDKERNDIAGGRADX Gradient of compound kernel's diagonal with respect to X.
%
% gX = cmpndKernDiagGradX(kern, X)

% Copyright (c) 2005 Neil D. Lawrence
% File version 1.3, Sat Jan  1 17:01:59 2005
% KERN toolbox version 0.131



i = 1;
if ~isempty(kern.comp{i}.index)
  % only part of the data is involved with the kernel.
  gX = zeros(size(X));
  gX(:, kern.comp{i}.index) = kernDiagGradX(kern.comp{i}, ...
                                        X(:, kern.comp{i}.index));
else
  % all the data is involved with the kernel.
  gX = kernDiagGradX(kern.comp{i}, X);
end
for i = 2:length(kern.comp)
  if ~isempty(kern.comp{i}.index)
    % only part of the data is involved with the kernel.
    gX(:, kern.comp{i}.index) = ...
        gX(:, kern.comp{i}.index) + ...
        kernDiagGradX(kern.comp{i}, ...
                  X(:, kern.comp{i}.index));
  else
    % all the data is involved with the kernel.
    gX = gX + kernDiagGradX(kern.comp{i}, X);
  end
end
